/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view;

/**
 * The layout manager is responsible for laying out the diagram and painting it to the specified Graphics2D object.
 * This interface defines the contract for implemenations to follow.
 *
 * @author Pops
 * @author TCSDeveloper
 */
public interface LayoutManager {

    /**
     * This method is called by the DependencyRenderer to layout and print the diagram. This method is provided
     * the dependency to layout, the shape factory to retrieve the shapes from and the Graphics.
     *
     * @param dependency The dependency to layout
     * @param shapeFactory The shape factory to use
     * @param graphics The graphics object to paint to
     * @throws NullPointerException if any parameter is null
     * @throws RendererException if some exception occurred while laying out the dependency diagram
     */
    void layout(Dependency dependency, ShapeFactory shapeFactory, RendererGraphics graphics);

}
